// Skin-specific Javascript code for the root page.
(function (){
'use strict';

var duration, minDuration, maxDuration, beat;
duration = 30;
minDuration = 5;
maxDuration = 120;
beat = 0; 

var hpsAutomator = scOnLoads[scOnLoads.length] = {
  fPathTools : [ "ide:tplRootPge", "ide:tplRootNav", "ide:tplTools", ],
  fTimout : 1*1000,
  fPlay : false,
  fLoop : false,
  fStrings : [
  /*00*/      "Lancer","Lancer le défilement automatique du diaporama",
  /*02*/      "Arrêter","Arrêter le défilement automatique du diaporama",
  ""],

  /** hpsAutomator.onLoad : Main onLoad function called by the SCENARI framework. */
  onLoad : function() {
    try {
      var i = '<p id="range-tooltip" class="tooltip"><span id="range-value">' + duration +' s</span></p>';
      i += '<input type="range" value="' + duration + '" min="' + minDuration + '" max="' + maxDuration + '" step="5" id="range-slider" name="counter"/>';
      var vRangeCt = this.fRangeCt = scHPS.xAddElt("div", scPaLib.findNode(this.fPathTools[1]),"");
      vRangeCt.id = 'range-container';
      vRangeCt.innerHTML = i;
          
      var vPgBarCt = this.fPgBarCt = scHPS.xAddElt("div", scPaLib.findNode(this.fPathTools[0]),"");
      vPgBarCt.id = 'progress-container';
      vPgBarCt.innerHTML = '<div id="progress-bar" style="width:0%; height:100%; transition:width 1s; transition-timing-function:linear;"></div>';  
      
      var vBtnPlay = this.fBtnPlay = scHPS.xAddElt("a", scPaLib.findNode(this.fPathTools[1]), "btnPlay", this.fPlay);
      vBtnPlay.innerHTML = "<i></i><span>"+this.fStrings[0]+"</span>";
      vBtnPlay.title = this.fStrings[1];
      vBtnPlay.onclick = this.sPlay;
      
      var vBtnPause = this.fBtnPause = scHPS.xAddElt("a", scPaLib.findNode(this.fPathTools[1]), "btnPause", !this.fPlay);
      vBtnPause.innerHTML = "<i></i><span>"+this.fStrings[2]+"</span>";
      vBtnPause.title = this.fStrings[3];
      vBtnPause.onclick = this.sPause;

      hpsAutomator.getRangeValue();
      
      this.fHeartbeat = window.setInterval(function(){hpsAutomator.sHeartbeat()},this.fTimout);
      scPresMgr.register("onAction", this.sOnAction);
    } catch(e){ scCoLib.log("ERROR - hpsAutomator.onLoad : "+e)}
  },
  /** hpsAutomator.sHeartbeat */
  sHeartbeat : function() {
    if (hpsAutomator.fPlay){
        hpsAutomator.fBtnPlay.style.display = "none";
        hpsAutomator.fBtnPause.style.display = "";
        beat++;
        if (beat > duration){
            beat = 0;
            if (scPresMgr.hasNext()) scPresMgr.next();
                else {
                    scPresMgr.loadSlide(-1, true, false);
                    if (hpsAutomator.fLoop) hpsAutomator.sPlay();
                    else hpsAutomator.sPause();
                }                           
            }
            hpsAutomator.moveProgressBar();
        } 
        else {
            hpsAutomator.fBtnPlay.style.display = "";
            hpsAutomator.fBtnPause.style.display = "none";
            }
    },
  /** hpsAutomator.sOnAction */
  sOnAction : function(pAction) {
    if (pAction === "showZoom" && hpsAutomator.fPlay) hpsAutomator.sPause();
  },
  /** hpsAutomator.sPlay */
  sPlay : function() {
    hpsAutomator.fPlay = true;
    hpsAutomator.fBtnPlay.style.display = "none";
    hpsAutomator.fBtnPause.style.display = "";
  },
  /** hpsAutomator.sPause */
  sPause : function() {
    hpsAutomator.fPlay = false;
    hpsAutomator.fBtnPlay.style.display = "";
    hpsAutomator.fBtnPause.style.display = "none";
  },
  /** hpsAutomator.moveProgressBar*/
  moveProgressBar : function() {
      if ( document.getElementById('progress-bar') ) {
          var w = (beat * (100 / duration))
          document.getElementById('progress-bar').style.width = w + '%';
          if ( w > 0 && w <= 100 ) {
              document.getElementById('progress-bar').style.visibility = 'visible';
          }
          else {
              document.getElementById('progress-bar').style.visibility = 'hidden';
              }
          }
      },
   /** hpsAutomator.getRangeValue*/   
   getRangeValue : function(){
       if ( document.getElementById("range-slider") && document.getElementById("range-value") ){
          var s = document.getElementById("range-slider");
          var o = document.getElementById("range-value");
          o.innerHTML = s.value + ' s';
          duration = s.value;
          s.oninput = function(){
            o.innerHTML = this.value + ' s';
            duration = this.value;
            }
          }
      }, 
  loadSortKey:"Z"
}
}) ();


